/* Copyright (C) 1991, 1997, 2003 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */


/*********************************************************************************
 * Copyright (c) 2012 China Standard Software Co (CS2C).
 * All rights reserved.
 *
 * This file is a part of Glibc ; before you use, modify and/or redistribute
 * it, you should get the permission from the China Standard Software Co
 * (http://cs2c.com.cn).
 *
 * Author(s)    : Zhang Jiuling<jiuling.zhang@cs2c.com.cn>
 *********************************************************************************/



#ifndef	_SYS_IO_H
#define	_SYS_IO_H	1

#include	<sys/syscall.h>
#include	<unistd.h>
#include	<errno.h>

#define		__NR_MIPSIO	5295

static inline ioperm (unsigned long int __from, unsigned long int __num, int __turn_on)
{
	return EIO;
}

static inline iopl (int __level)
{
	return EIO;
}

typedef enum
{
	io_outb,
	io_outw,
	io_outl,
	io_outsb,
	io_outsw,
	io_outsl,
	io_inb,
	io_inw,
	io_inl,
	io_insb,
	io_insw,
	io_insl,
	io_outb_p,
	io_outw_p,
	io_outl_p,
	io_inb_p,
	io_inw_p,
	io_inl_p
} IO_TYPE;

static inline void
outb (unsigned char __value, unsigned short int __port)
{
	syscall(__NR_MIPSIO, io_outb, __value, __port, 0);
}

static inline void
outw (unsigned short int __value, unsigned short int __port)
{
	syscall(__NR_MIPSIO, io_outw, __value, __port, 0);
}

static inline void
outl (unsigned int __value, unsigned short int __port)
{
	syscall(__NR_MIPSIO, io_outl, __value, __port, 0);
}

static inline void
outsb (unsigned short int __port, const void *addr, unsigned long int __count)
{
	syscall(__NR_MIPSIO, io_outsb, __port, addr, __count);
}

static inline void
outsw (unsigned short int __port, const void *addr, unsigned long int __count)
{
	syscall(__NR_MIPSIO, io_outsw, __port, addr, __count);
}

static inline void
outsl (unsigned short int __port, const void *addr, unsigned long int __count)
{
	syscall(__NR_MIPSIO, io_outsl, __port, addr, __count);
}

static inline unsigned char
inb (unsigned short int __port)
{
	return syscall(__NR_MIPSIO, io_inb, __port, 0, 0);
}

static inline unsigned short int
inw (unsigned short int __port)
{
	return syscall(__NR_MIPSIO, io_inw, __port, 0, 0);
}

static inline unsigned int
inl (unsigned short int __port)
{
	return syscall(__NR_MIPSIO, io_inl, __port, 0, 0);
}

static inline void
insb (unsigned short int __port, void *addr, unsigned long int __count)
{
	syscall(__NR_MIPSIO, io_insb, __port, addr, __count);
}

static inline void
insw (unsigned short int __port, void *addr, unsigned long int __count)
{
	syscall(__NR_MIPSIO, io_insw, __port, addr, __count);
}

static inline void
insl (unsigned short int __port, void *addr, unsigned long int __count)
{
	syscall(__NR_MIPSIO, io_insl, __port, addr, __count);
}

static inline void
outb_p (unsigned char __value, unsigned short int __port)
{
	syscall(__NR_MIPSIO, io_outb_p, __value, __port, 0);
}

static inline void
outw_p (unsigned short int __value, unsigned short int __port)
{
	syscall(__NR_MIPSIO, io_outw_p, __value, __port, 0);
}

static inline void
outl_p (unsigned int __value, unsigned short int __port)
{
	syscall(__NR_MIPSIO, io_outl_p, __value, __port, 0);
}

static inline unsigned char
inb_p (unsigned short int __port)
{
	return syscall(__NR_MIPSIO, io_inb_p, __port, 0, 0);
}

static inline unsigned short int
inw_p (unsigned short int __port)
{
	return syscall(__NR_MIPSIO, io_inw_p, __port, 0, 0);
}

static inline unsigned int
inl_p (unsigned short int __port)
{
	return syscall(__NR_MIPSIO, io_inl_p, __port, 0, 0);
}

#endif /* _SYS_IO_H */
